#include once "inc/serverlib.bi"
#include once "inc/public_errors.bi"

#ifndef NULL
#define NULL cptr(any ptr,0) 
#endif

sub MyCallbackVoiceDataEvent cdecl (serverID as uint64, clientID as anyID, voiceData as ubyte ptr, voiceDataSize as uinteger, frequency as uinteger)
  print "MyCallbackVoiceDataEvent: "
end sub

sub MyCallbackClientStartTalkingEvent cdecl (serverID as uint64, clientID as anyID)
  print "MyCallbackClientStartTalkingEvent: "
end sub

sub MyCallbackClientStopTalkingEvent cdecl (serverID as uint64, clientID as anyID)
  print "MyCallbackClientStopTalkingEvent: "
end sub

sub MyCallbackClientConnected cdecl (serverID as uint64, clientID as anyID, channelID as uint64, removeClientError as uinteger ptr)
  print "MyCallbackClientConnected: " & clientID
end sub

sub MyCallbackClientDisconnected cdecl (serverID as uint64, clientID as anyID, channelID as uint64)
  print "MyCallbackClientDisconnected: " & clientID
end sub

sub MyCallbackClientMoved cdecl (serverID as uint64, clientID as anyID, oldChannelID as uint64, newChannelID as uint64)
  print "MyCallbackClientMoved: "
end sub

sub MyCallbackChannelCreated cdecl (serverID as uint64, invokerClientID as anyID, channelID as uint64)
  print "MyCallbackChannelCreated: "
end sub

sub MyCallbackChannelEdited cdecl (serverID as uint64, invokerClientID as anyID, channelID as uint64)
  print "MyCallbackChannelEdited: "
end sub

sub MyCallbackChannelDeleted cdecl (serverID as uint64, invokerClientID as anyID, channelID as uint64)
  print "MyCallbackChannelDeleted: "
end sub

sub MyCallbackServerTextMessageEvent cdecl (serverID as uint64, invokerClientID as anyID, textMessage as const zstring ptr)
  print "MyCallbackServerTextMessageEvent: "
end sub

sub MyCallbackChannelTextMessageEvent cdecl (serverID as uint64, invokerClientID as anyID, targetChannelID as uint64, textMessage as const zstring ptr)
  print "MyCallbackChannelTextMessageEvent: "
end sub

sub MyCallbackUserLoggingMessageEvent cdecl (logmessage as const zstring ptr, logLevel as integer, logChannel as const zstring ptr, logID as uint64, logTime as const zstring ptr, completeLogString as const zstring ptr)
  print "MyCallbackUserLoggingMessageEvent: logTime" & *logTime
  print "message: " & * logmessage
  print
end sub

sub MyCallbackAccountingErrorEvent cdecl (serverID as uint64, errorCode as uinteger)
  print "MyCallbackAccountingErrorEvent: " & errorCode
end sub

sub MyCallbackCustomPacketEncryptEvent cdecl (dataToSend as zstring ptr ptr, sizeOfData as uinteger ptr)
end sub

sub MyCallbackCustomPacketDecryptEvent cdecl (dataReceived as zstring ptr ptr, dataReceivedSize as uinteger ptr) 
end sub

'
' main
'
dim as ServerLibFunctions MyServerCallbacks


with MyServerCallbacks
  .onVoiceDataEvent           = @MyCallbackVoiceDataEvent
  .onClientStartTalkingEvent  = @MyCallbackClientStartTalkingEvent
  .onClientStopTalkingEvent   = @MyCallbackClientStopTalkingEvent
  .onClientConnected          = @MyCallbackClientConnected
  .onClientDisconnected       = @MyCallbackClientDisconnected
  .onClientMoved              = @MyCallbackClientMoved
  .onChannelCreated           = @MyCallbackChannelCreated
  .onChannelEdited            = @MyCallbackChannelEdited
  .onChannelDeleted           = @MyCallbackChannelDeleted
  .onServerTextMessageEvent   = @MyCallbackServerTextMessageEvent
  .onChannelTextMessageEvent  = @MyCallbackChannelTextMessageEvent
  .onUserLoggingMessageEvent  = @MyCallbackUserLoggingMessageEvent
  .onAccountingErrorEvent     = @MyCallbackAccountingErrorEvent
  .onCustomPacketEncryptEvent = NULL '@MyCallbackCustomPacketEncryptEvent
  .onCustomPacketDecryptEvent = NULL '@MyCallbackCustomPacketDecryptEvent
end with

if ts3server_initServerLib(@MyServerCallbacks,LogType_USERLOGGING,NULL) then
  print "error: initServerLib() !"
  beep:sleep:end 1
end if
dim as uint64 ServerID
if ts3server_createVirtualServer(9987      , _ ' UDP port
                                 "0.0.0.0" , _ ' accept any IP
                                 "MyServer", _ ' name
                                 ""        , _ ' key pair
                                 32        , _ ' max slots/clients
                                 @serverID) then
  print "error: createVirtualServer() !"
  ts3server_destroyServerLib
  beep:sleep:end 1
end if
? "serverID: " & serverID

dim as zstring ptr pKey
if ts3server_getVirtualServerKeyPair(serverID,@pKey) then
  print "error: getVirtualServerKeyPair() !"
  ts3server_stopVirtualServer serverID
  ts3server_destroyServerLib
  beep:sleep:end 1
end if
print "KeyPair: " & *pKey
print
print "any key = quit ..."
while inkey=""
  sleep 10
wend
ts3server_stopVirtualServer serverID
ts3server_destroyServerLib
sleep
