#ifndef CLIENTLIB_BI
#define CLIENTLIB_BI
/'
 * This is the main header for the TeamSpeak 3 Client SDK. All the functions that are used
 * to communicate with the Teamspeak 3 Client are here. Please view the documentation for
 * details. Note that some of these functions REQUIRE you to call ts3sclient_freeMemory()
 * after finishing with the result. This holds true for all the functions returning strings
 * (so the parameter is "char** result"). Again, the details are all in the documentation.
 '/

' system
#include once "crt/stdlib.bi"

' own
#include once "clientlib_publicdefinitions.bi"
#include once "public_definitions.bi"

#ifdef __FB_WIN32__
#define LIBNAME "ts3client_win32"
#else
#define LIBNAME "ts3client_linux_x86"
#endif

extern "C"

type ClientUIFunctionsRare as any 

type ClientUIFunctions
  as sub (serverConnectionHandlerID as uint64, newStatus as integer, errorNumber as uinteger) onConnectStatusChangeEvent
  as sub (serverConnectionHandlerID as uint64, protocolVersion as integer) onServerProtocolVersionEvent
  as sub (serverConnectionHandlerID as uint64, channelID as uint64, channelParentID as uint64) onNewChannelEvent
  as sub (serverConnectionHandlerID as uint64, channelID as uint64, channelParentID as uint64, invokerID as anyID, invokerName as const zstring ptr, invokerUniqueIdentifier as const zstring ptr) onNewChannelCreatedEvent
  as sub (serverConnectionHandlerID as uint64, channelID as uint64, invokerID as anyID, invokerName as const zstring ptr, invokerUniqueIdentifier as const zstring ptr) onDelChannelEvent
  as sub (serverConnectionHandlerID as uint64, channelID as uint64, newChannelParentID as uint64, invokerID as anyID, invokerName as const zstring ptr, invokerUniqueIdentifier as const zstring ptr) onChannelMoveEvent
  as sub (serverConnectionHandlerID as uint64, channelID as uint64) onUpdateChannelEvent
  as sub (serverConnectionHandlerID as uint64, channelID as uint64, invokerID as anyID, invokerName as const zstring ptr, invokerUniqueIdentifier as const zstring ptr) onUpdateChannelEditedEvent
  as sub (serverConnectionHandlerID as uint64, clientID as anyID, invokerID as anyID, invokerName as const zstring ptr, invokerUniqueIdentifier as const zstring ptr) onUpdateClientEvent
  as sub (serverConnectionHandlerID as uint64, clientID as anyID, oldChannelID as uint64,newChannelID as uint64, visibility as integer, moveMessage as const zstring ptr) onClientMoveEvent
  as sub (serverConnectionHandlerID as uint64, clientID as anyID, oldChannelID as uint64,newChannelID as uint64, visibility as integer) onClientMoveSubscriptionEvent
  as sub (serverConnectionHandlerID as uint64, clientID as anyID, oldChannelID as uint64,newChannelID as uint64, visibility as integer, timeoutMessage as const zstring ptr) onClientMoveTimeoutEvent
  as sub (serverConnectionHandlerID as uint64, clientID as anyID, oldChannelID as uint64,newChannelID as uint64, visibility as integer, moverID  as anyID, moverName as const zstring ptr, moverUniqueIdentifier as const zstring ptr, moveMessage as const zstring ptr) onClientMoveMovedEvent
  as sub (serverConnectionHandlerID as uint64, clientID as anyID, oldChannelID as uint64,newChannelID as uint64, visibility as integer, kickerID as anyID, kickerName as const zstring ptr, kickerUniqueIdentifier as const zstring ptr, kickMessage as const zstring ptr) onClientKickFromChannelEvent
  as sub (serverConnectionHandlerID as uint64, clientID as anyID, oldChannelID as uint64,newChannelID as uint64, visibility as integer, kickerID as anyID, kickerName as const zstring ptr, kickerUniqueIdentifier as const zstring ptr, kickMessage as const zstring ptr) onClientKickFromServerEvent
  as sub (serverConnectionHandlerID as uint64, uniqueClientIdentifier as const zstring ptr, clientID as anyID, clientName as const zstring ptr) onClientIDsEvent
  as sub (serverConnectionHandlerID as uint64) onClientIDsFinishedEvent
  as sub (serverConnectionHandlerID as uint64, editerID as anyID, editerName as const zstring ptr, editerUniqueIdentifier as const zstring ptr) onServerEditedEvent
  as sub (serverConnectionHandlerID as uint64) onServerUpdatedEvent
  as sub (serverConnectionHandlerID as uint64, errorMessage as const zstring ptr, errorcode as uinteger, returnCode as const zstring ptr, extraMessage as const zstring ptr) onServerErrorEvent
  as sub (serverConnectionHandlerID as uint64, shutdownMessage as const zstring ptr) onServerStopEvent
  as sub (serverConnectionHandlerID as uint64, targetMode as anyID, toID as anyID, fromID as anyID, fromName as const zstring ptr, fromUniqueIdentifier as const zstring ptr, message as const zstring ptr) onTextMessageEvent
  as sub (serverConnectionHandlerID as uint64, status as integer, isReceivedWhisper as integer, clientID as anyID) onTalkStatusChangeEvent
  as sub (serverConnectionHandlerID as uint64, clientID as anyID) onIgnoredWhisperEvent
  as sub (serverConnectionHandlerID as uint64, clientID as anyID) onConnectionInfoEvent
  as sub (serverConnectionHandlerID as uint64) onServerConnectionInfoEvent
  as sub (serverConnectionHandlerID as uint64, channelID as uint64) onChannelSubscribeEvent
  as sub (serverConnectionHandlerID as uint64) onChannelSubscribeFinishedEvent
  as sub (serverConnectionHandlerID as uint64, channelID as uint64) onChannelUnsubscribeEvent
  as sub (serverConnectionHandlerID as uint64) onChannelUnsubscribeFinishedEvent
  as sub (serverConnectionHandlerID as uint64, channelID as uint64) onChannelDescriptionUpdateEvent
  as sub (serverConnectionHandlerID as uint64, channelID as uint64) onChannelPasswordChangedEvent
  as sub (serverConnectionHandlerID as uint64) onPlaybackShutdownCompleteEvent
  as sub (modeID as const zstring ptr, playOrCap as integer) onSoundDeviceListChangedEvent
  as sub (serverConnectionHandlerID as uint64, clientID as anyID, samples as short ptr, sampleCount as integer, channels as integer) onEditPlaybackVoiceDataEvent
  as sub (serverConnectionHandlerID as uint64, clientID as anyID, samples as short ptr, sampleCount as integer, channels as integer, channelSpeakerArray as const uinteger ptr, channelFillMask as uinteger ptr) onEditPostProcessVoiceDataEvent
  as sub (serverConnectionHandlerID as uint64, samples as short ptr, sampleCount as integer, channels as integer, channelSpeakerArray as const uinteger ptr, channelFillMask as uinteger ptr) onEditMixedPlaybackVoiceDataEvent
  as sub (serverConnectionHandlerID as uint64, samples as short ptr, sampleCount as integer, channels as integer, edited as integer ptr) onEditCapturedVoiceDataEvent
  as sub (serverConnectionHandlerID as uint64, clientID as anyID, distance as single, volume as single ptr) onCustom3dRolloffCalculationClientEvent
  as sub (serverConnectionHandlerID as uint64, waveHandle as uint64, distance as single, volume as single ptr) onCustom3dRolloffCalculationWaveEvent
  as sub (logmessage as const zstring ptr, logLevel as integer, logChannel as const zstring ptr, logID as uint64, logTime as const zstring ptr, completeLogString as const zstring ptr) onUserLoggingMessageEvent
  as sub (dataToSend as zstring ptr ptr, sizeOfData as uinteger ptr) onCustomPacketEncryptEvent
  as sub (dataReceived as zstring ptr ptr, dataReceivedSize as uinteger ptr) onCustomPacketDecryptEvent
  as sub (errorcode as uinteger, requestHandle as uint64, connectionKey as const zstring ptr) onProvisioningSlotRequestResultEvent
end type


' Memory management
declare function ts3client_freeMemory                lib LIBNAME (p as any ptr) as uinteger

' Construction and Destruction
declare function ts3client_initClientLib             lib LIBNAME (functionPointers as const ClientUIFunctions ptr, functionRarePointersconst as ClientUIFunctionsRare ptr, usedLogTypes as integer, logFileFolder as const zstring ptr, resourcesFolder as const zstring ptr) as uinteger
declare function ts3client_destroyClientLib          lib LIBNAME () as uinteger
declare function ts3client_getClientLibVersion       lib LIBNAME (result as zstring ptr ptr) as uinteger
declare function ts3client_getClientLibVersionNumber lib LIBNAME (result as uint64 ptr) as uinteger

declare function ts3client_spawnNewServerConnectionHandler lib LIBNAME (port as integer, result as uint64 ptr) as uinteger
declare function ts3client_destroyServerConnectionHandler  lib LIBNAME (serverConnectionHandlerID as uint64) as uinteger

' Identity management
declare function ts3client_createIdentity lib LIBNAME (result as zstring ptr ptr) as uinteger

' sound 
declare function ts3client_getPlaybackDeviceList    lib LIBNAME (modeID as const zstring ptr, result as const zstring ptr ptr ptr ptr) as uinteger
declare function ts3client_getCaptureDeviceList     lib LIBNAME (modeID as const zstring ptr, result as const zstring ptr ptr ptr ptr) as uinteger
declare function ts3client_getPlaybackModeList      lib LIBNAME (result as zstring ptr ptr ptr) as uinteger
declare function ts3client_getCaptureModeList       lib LIBNAME (result as zstring ptr ptr ptr) as uinteger
declare function ts3client_getDefaultPlaybackDevice lib LIBNAME (modeID as const zstring ptr, result as zstring ptr ptr ptr) as uinteger
declare function ts3client_getDefaultCaptureDevice  lib LIBNAME (modeID as const zstring ptr, result as zstring ptr ptr ptr) as uinteger
declare function ts3client_getDefaultPlayBackMode   lib LIBNAME (result as zstring ptr ptr) as uinteger
declare function ts3client_getDefaultCaptureMode    lib LIBNAME (result as zstring ptr ptr) as uinteger

declare function ts3client_openPlaybackDevice           lib LIBNAME (serverConnectionHandlerID as uint64, modeID as const zstring ptr, playbackDevice as const zstring ptr) as uinteger
declare function ts3client_openCaptureDevice            lib LIBNAME (serverConnectionHandlerID as uint64, modeID as const zstring ptr, captureDevice as const zstring ptr) as uinteger
declare function ts3client_getCurrentPlaybackDeviceName lib LIBNAME (serverConnectionHandlerID as uint64, result as zstring ptr ptr, isDefault as integer ptr) as uinteger
declare function ts3client_getCurrentPlayBackMode       lib LIBNAME (serverConnectionHandlerID as uint64, result as zstring ptr ptr) as uinteger
declare function ts3client_getCurrentCaptureDeviceName  lib LIBNAME (serverConnectionHandlerID as uint64, result as zstring ptr ptr, isDefault as integer ptr) as uinteger
declare function ts3client_getCurrentCaptureMode        lib LIBNAME (serverConnectionHandlerID as uint64, result as zstring ptr ptr) as uinteger
declare function ts3client_initiateGracefulPlaybackShutdown lib LIBNAME (serverConnectionHandlerID as uint64) as uinteger
declare function ts3client_closePlaybackDevice   lib LIBNAME (serverConnectionHandlerID as uint64) as uinteger
declare function ts3client_closeCaptureDevice    lib LIBNAME (serverConnectionHandlerID as uint64) as uinteger
declare function ts3client_activateCaptureDevice lib LIBNAME (serverConnectionHandlerID as uint64) as uinteger

declare function ts3client_playWaveFile        lib LIBNAME (serverConnectionHandlerID as uint64, path as const zstring ptr) as uinteger
declare function ts3client_playWaveFileHandle  lib LIBNAME (serverConnectionHandlerID as uint64, path as const zstring ptr, loops as integer, waveHandle as uint64 ptr) as uinteger
declare function ts3client_pauseWaveFileHandle lib LIBNAME (serverConnectionHandlerID as uint64, waveHandle as uint64, pause as integer) as uinteger
declare function ts3client_closeWaveFileHandle lib LIBNAME (serverConnectionHandlerID as uint64, waveHandle as uint64) as uinteger

declare function ts3client_registerCustomDevice      lib LIBNAME (deviceID as const zstring ptr, deviceDisplayName as const zstring ptr, capFrequency as integer, capChannels as integer, playFrequency as integer, playChannels as integer) as uinteger
declare function ts3client_unregisterCustomDevice    lib LIBNAME (deviceID as const zstring ptr) as uinteger
declare function ts3client_processCustomCaptureData  lib LIBNAME (deviceName as const zstring ptr, buffer as const short ptr, samples as integer) as uinteger
declare function ts3client_acquireCustomPlaybackData lib LIBNAME (deviceName as const zstring ptr, buffer as short ptr, samples as integer) as uinteger

declare function ts3client_setLocalTestMode    lib LIBNAME (serverConnectionHandlerID as uint64, status as integer) as uinteger

declare function ts3client_startVoiceRecording lib LIBNAME (serverConnectionHandlerID as uint64) as uinteger
declare function ts3client_stopVoiceRecording  lib LIBNAME (serverConnectionHandlerID as uint64) as uinteger

declare function ts3client_allowWhispersFrom             lib LIBNAME (serverConnectionHandlerID as uint64, clID as anyID) as uinteger
declare function ts3client_removeFromAllowedWhispersFrom lib LIBNAME (serverConnectionHandlerID as uint64, clID as anyID) as uinteger

' 3d sound positioning
declare function ts3client_systemset3DListenerAttributes lib LIBNAME (serverConnectionHandlerID as uint64, position as const TS3_VECTOR ptr, forward as const TS3_VECTOR ptr, up as const TS3_VECTOR ptr) as uinteger
declare function ts3client_set3DWaveAttributes           lib LIBNAME (serverConnectionHandlerID as uint64, waveHandle as uint64, position as const TS3_VECTOR ptr) as uinteger
declare function ts3client_systemset3DSettings           lib LIBNAME (serverConnectionHandlerID as uint64, distanceFactor as single, rolloffScale as single) as uinteger
declare function ts3client_channelset3DAttributes        lib LIBNAME (serverConnectionHandlerID as uint64, clientID as anyID, position as const TS3_VECTOR ptr) as uinteger

' preprocessor
declare function ts3client_getPreProcessorInfoValueFloat lib LIBNAME (serverConnectionHandlerID as uint64, ident as const zstring ptr, result as single ptr) as uinteger
declare function ts3client_getPreProcessorConfigValue    lib LIBNAME (serverConnectionHandlerID as uint64, ident as const zstring ptr, result as zstring ptr ptr) as uinteger
declare function ts3client_setPreProcessorConfigValue    lib LIBNAME (serverConnectionHandlerID as uint64, ident as const zstring ptr, value as const zstring ptr) as uinteger

' encoder
declare function ts3client_getEncodeConfigValue lib LIBNAME (serverConnectionHandlerID as uint64, ident as const zstring ptr, result as zstring ptr ptr) as uinteger

' playback
declare function ts3client_getPlaybackConfigValueAsFloat lib LIBNAME (serverConnectionHandlerID as uint64, ident as const zstring ptr, result as single ptr) as uinteger
declare function ts3client_setPlaybackConfigValue        lib LIBNAME (serverConnectionHandlerID as uint64, ident as const zstring ptr, value as const zstring ptr) as uinteger
declare function ts3client_setClientVolumeModifier       lib LIBNAME (serverConnectionHandlerID as uint64, clientID as anyID, value as single) as uinteger

' logging
declare function ts3client_logMessage      lib LIBNAME (logMessage as const zstring ptr, severity as LogLevel , channel as const zstring ptr, logID as uint64) as uinteger
declare function ts3client_setLogVerbosity lib LIBNAME (logVerbosity as LogLevel ) as uinteger

' error handling
declare function ts3client_getErrorMessage lib LIBNAME (errorCode as uinteger, errorStr as zstring ptr ptr) as uinteger

' Interacting with the server
declare function ts3client_startConnection              lib LIBNAME (serverConnectionHandlerID as uint64, identity as const zstring ptr, ip as const zstring ptr, port as uinteger, nickname as const zstring ptr, _
                                                                                   defaultChannelArray as const zstring ptr ptr, defaultChannelPassword as const zstring ptr, serverPassword as const zstring ptr) as uinteger
declare function ts3client_stopConnection               lib LIBNAME (serverConnectionHandlerID as uint64, quitMessage as const zstring ptr) as uinteger
declare function ts3client_requestClientMove            lib LIBNAME (serverConnectionHandlerID as uint64, clientID as anyID, newChannelID as uint64, password as const zstring ptr, returnCode as const zstring ptr) as uinteger
declare function ts3client_requestClientVariables       lib LIBNAME (serverConnectionHandlerID as uint64, clientID as anyID, returnCode as const zstring ptr) as uinteger
declare function ts3client_requestClientKickFromChannel lib LIBNAME (serverConnectionHandlerID as uint64, clientID as anyID, kickReason as const zstring ptr, returnCode as const zstring ptr) as uinteger
declare function ts3client_requestClientKickFromServer  lib LIBNAME (serverConnectionHandlerID as uint64, clientID as anyID, kickReason as const zstring ptr, returnCode as const zstring ptr) as uinteger
declare function ts3client_requestChannelDelete         lib LIBNAME (serverConnectionHandlerID as uint64, channelID as uint64, force as integer, returnCode as const zstring ptr) as uinteger
declare function ts3client_requestChannelMove           lib LIBNAME (serverConnectionHandlerID as uint64, channelID as uint64, newChannelParentID as uint64, newChannelOrder as uint64, returnCode as const zstring ptr) as uinteger
declare function ts3client_requestSendPrivateTextMsg    lib LIBNAME (serverConnectionHandlerID as uint64, message as const zstring ptr, targetClientID as anyID, returnCode as const zstring ptr) as uinteger
declare function ts3client_requestSendChannelTextMsg    lib LIBNAME (serverConnectionHandlerID as uint64, message as const zstring ptr, targetChannelID as uint64, returnCode as const zstring ptr) as uinteger
declare function ts3client_requestSendServerTextMsg     lib LIBNAME (serverConnectionHandlerID as uint64, message as const zstring ptr, returnCode as const zstring ptr) as uinteger
declare function ts3client_requestConnectionInfo        lib LIBNAME (serverConnectionHandlerID as uint64, clientID as anyID, returnCode as const zstring ptr) as uinteger
declare function ts3client_requestClientSetWhisperList  lib LIBNAME (serverConnectionHandlerID as uint64, clientID as anyID, targetChannelIDArray as const uint64 ptr, targetClientIDArray as const anyID ptr, returnCode as const zstring ptr) as uinteger
declare function ts3client_requestChannelSubscribe      lib LIBNAME (serverConnectionHandlerID as uint64, channelIDArray as const uint64 ptr, returnCode as const zstring ptr) as uinteger
declare function ts3client_requestChannelSubscribeAll   lib LIBNAME (serverConnectionHandlerID as uint64, returnCode as const zstring ptr) as uinteger
declare function ts3client_requestChannelUnsubscribe    lib LIBNAME (serverConnectionHandlerID as uint64, channelIDArray as const uint64 ptr, returnCode as const zstring ptr) as uinteger
declare function ts3client_requestChannelUnsubscribeAll lib LIBNAME (serverConnectionHandlerID as uint64, returnCode as const zstring ptr) as uinteger
declare function ts3client_requestChannelDescription    lib LIBNAME (serverConnectionHandlerID as uint64, channelID as uint64, returnCode as const zstring ptr) as uinteger
declare function ts3client_requestMuteClients           lib LIBNAME (serverConnectionHandlerID as uint64, clientIDArray as const anyID ptr, returnCode as const zstring ptr) as uinteger
declare function ts3client_requestUnmuteClients         lib LIBNAME (serverConnectionHandlerID as uint64, clientIDArray as const anyID ptr, returnCode as const zstring ptr) as uinteger
declare function ts3client_requestClientIDs             lib LIBNAME (serverConnectionHandlerID as uint64, clientUniqueIdentifier as const zstring ptr, returnCode as const zstring ptr) as uinteger

' provisioning server calls
declare function ts3client_requestSlotsFromProvisioningServer       lib LIBNAME (ip as const zstring ptr, port as ushort, serverPassword as const zstring ptr, slots as ushort, identity as const zstring ptr, region as const zstring ptr, requestHandle as uint64 ptr) as uinteger
declare function ts3client_cancelRequestSlotsFromProvisioningServer lib LIBNAME (requestHandle as uint64) as uinteger
declare function ts3client_startConnectionWithProvisioningKey       lib LIBNAME (serverConnectionHandlerID as uint64, identity as const zstring ptr, nickname as const zstring ptr, connectionKey as const zstring ptr) as uinteger

' retrieve information ClientLib has stored

' general info
declare function ts3client_getClientID lib LIBNAME (serverConnectionHandlerID as uint64, result as anyID ptr) as uinteger

' client connection info
declare function ts3client_getConnectionStatus           lib LIBNAME (serverConnectionHandlerID as uint64, result as integer ptr) as uinteger
declare function ts3client_getConnectionVariableAsUInt64 lib LIBNAME (serverConnectionHandlerID as uint64, clientID as anyID, flag as integer, result as uint64 ptr) as uinteger
declare function ts3client_getConnectionVariableAsDouble lib LIBNAME (serverConnectionHandlerID as uint64, clientID as anyID, flag as integer, result as double ptr) as uinteger
declare function ts3client_getConnectionVariableAsString lib LIBNAME (serverConnectionHandlerID as uint64, clientID as anyID, flag as integer, result as zstring ptr ptr) as uinteger
declare function ts3client_cleanUpConnectionInfo         lib LIBNAME (serverConnectionHandlerID as uint64, clientID as anyID) as uinteger

' server connection info
declare function ts3client_requestServerConnectionInfo         lib LIBNAME (serverConnectionHandlerID as uint64, returnCode as const zstring ptr) as uinteger
declare function ts3client_getServerConnectionVariableAsUInt64 lib LIBNAME (serverConnectionHandlerID as uint64, flag as integer, result as uint64 ptr) as uinteger
declare function ts3client_getServerConnectionVariableAsFloat  lib LIBNAME (serverConnectionHandlerID as uint64, flag as integer, result as single ptr) as uinteger

' client info
declare function ts3client_getClientSelfVariableAsInt    lib LIBNAME (serverConnectionHandlerID as uint64, flag as integer, result as integer ptr) as uinteger
declare function ts3client_getClientSelfVariableAsString lib LIBNAME (serverConnectionHandlerID as uint64, flag as integer, result as zstring ptr ptr) as uinteger
declare function ts3client_setClientSelfVariableAsInt    lib LIBNAME (serverConnectionHandlerID as uint64, flag as integer, value as integer) as uinteger
declare function ts3client_setClientSelfVariableAsString lib LIBNAME (serverConnectionHandlerID as uint64, flag as integer, value as const zstring ptr) as uinteger
declare function ts3client_flushClientSelfUpdates        lib LIBNAME (serverConnectionHandlerID as uint64, returnCode as const zstring ptr) as uinteger

declare function ts3client_getClientVariableAsInt    lib LIBNAME (serverConnectionHandlerID as uint64, clientID as anyID, flag as integer, result as integer ptr) as uinteger
declare function ts3client_getClientVariableAsUInt64 lib LIBNAME (serverConnectionHandlerID as uint64, clientID as anyID, flag as integer, result as uint64 ptr) as uinteger
declare function ts3client_getClientVariableAsString lib LIBNAME (serverConnectionHandlerID as uint64, clientID as anyID, flag as integer, result as zstring ptr ptr) as uinteger

declare function ts3client_getClientList      lib LIBNAME (serverConnectionHandlerID as uint64, result as anyID ptr ptr) as uinteger
declare function ts3client_getChannelOfClient lib LIBNAME (serverConnectionHandlerID as uint64, clientID as anyID, result as uint64 ptr) as uinteger

' channel info
declare function ts3client_getChannelVariableAsInt    lib LIBNAME (serverConnectionHandlerID as uint64, channelID as uint64, flag as integer, result as integer ptr) as uinteger
declare function ts3client_getChannelVariableAsUInt64 lib LIBNAME (serverConnectionHandlerID as uint64, channelID as uint64, flag as integer, result as uint64 ptr) as uinteger
declare function ts3client_getChannelVariableAsString lib LIBNAME (serverConnectionHandlerID as uint64, channelID as uint64, flag as integer, result as zstring ptr ptr) as uinteger

declare function ts3client_getChannelIDFromChannelNames lib LIBNAME (serverConnectionHandlerID as uint64, channelNameArray as zstring ptr ptr, result as uint64 ptr) as uinteger
declare function ts3client_setChannelVariableAsInt      lib LIBNAME (serverConnectionHandlerID as uint64, channelID as uint64, flag as integer, value as integer) as uinteger
declare function ts3client_setChannelVariableAsUInt64   lib LIBNAME (serverConnectionHandlerID as uint64, channelID as uint64, flag as integer, value as uint64) as uinteger
declare function ts3client_setChannelVariableAsString   lib LIBNAME (serverConnectionHandlerID as uint64, channelID as uint64, flag as integer, value as const zstring ptr) as uinteger
declare function ts3client_flushChannelUpdates          lib LIBNAME (serverConnectionHandlerID as uint64, channelID as uint64) as uinteger
declare function ts3client_flushChannelCreation         lib LIBNAME (serverConnectionHandlerID as uint64, channelParentID as uint64) as uinteger

declare function ts3client_getChannelList            lib LIBNAME (serverConnectionHandlerID as uint64, result as uint64 ptr ptr) as uinteger
declare function ts3client_getChannelClientList      lib LIBNAME (serverConnectionHandlerID as uint64, channelID as uint64, result as anyID ptr ptr ) as uinteger
declare function ts3client_getParentChannelOfChannel lib LIBNAME (serverConnectionHandlerID as uint64, channelID as uint64, result as uint64 ptr) as uinteger

' server info
declare function ts3client_getServerConnectionHandlerList lib LIBNAME (result as uint64 ptr) as uinteger
declare function ts3client_getServerVariableAsInt         lib LIBNAME (serverConnectionHandlerID as uint64, flag as integer, result as integer ptr) as uinteger
declare function ts3client_getServerVariableAsUInt64      lib LIBNAME (serverConnectionHandlerID as uint64, flag as integer, result as uint64 ptr ) as uinteger
declare function ts3client_getServerVariableAsString      lib LIBNAME (serverConnectionHandlerID as uint64, flag as integer, result as zstring ptr ptr) as uinteger
declare function ts3client_requestServerVariables         lib LIBNAME (serverConnectionHandlerID as uint64) as uinteger

end extern

#undef LIBNAME

#endif ' CLIENTLIB_BI
