#ifndef PUBLIC_ERRORS_BI
#define PUBLIC_ERRORS_BI

' The idea here is: the values are 2 bytes wide, the first byte identifies the group, the second the count within that group

' general
const as uinteger ERROR_ok                                     = &H0000
const as uinteger ERROR_undefined                              = &H0001
const as uinteger ERROR_not_implemented                        = &H0002
const as uinteger ERROR_ok_no_update                           = &H0003
const as uinteger ERROR_dont_notify                            = &H0004

' dunno
const as uinteger ERROR_command_not_found                      = &H0100
const as uinteger ERROR_unable_to_bind_network_port            = &H0101
const as uinteger ERROR_no_network_port_available              = &H0102

' client
const as uinteger ERROR_client_invalid_id                      = &H0200
const as uinteger ERROR_client_nickname_inuse                  = &H0201
const as uinteger ERROR_client_protocol_limit_reached          = &H0203
const as uinteger ERROR_client_invalid_type                    = &H0204
const as uinteger ERROR_client_already_subscribed              = &H0205
const as uinteger ERROR_client_not_logged_in                   = &H0206
const as uinteger ERROR_client_could_not_validate_identity     = &H0207
const as uinteger ERROR_client_version_outdated                = &H020a
const as uinteger ERROR_client_is_flooding                     = &H020c

' channel
const as uinteger ERROR_channel_invalid_id                     = &H0300
const as uinteger ERROR_channel_protocol_limit_reached         = &H0301
const as uinteger ERROR_channel_already_in                     = &H0302
const as uinteger ERROR_channel_name_inuse                     = &H0303
const as uinteger ERROR_channel_not_empty                      = &H0304
const as uinteger ERROR_channel_can_not_delete_default         = &H0305
const as uinteger ERROR_channel_default_require_permanent      = &H0306
const as uinteger ERROR_channel_invalid_flags                  = &H0307
const as uinteger ERROR_channel_parent_not_permanent           = &H0308
const as uinteger ERROR_channel_maxclients_reached             = &H0309
const as uinteger ERROR_channel_maxfamily_reached              = &H030a
const as uinteger ERROR_channel_invalid_order                  = &H030b
const as uinteger ERROR_channel_no_filetransfer_supported      = &H030c
const as uinteger ERROR_channel_invalid_password               = &H030d

' server
const as uinteger ERROR_server_invalid_id                      = &H0400
const as uinteger ERROR_server_running                         = &H0401
const as uinteger ERROR_server_is_shutting_down                = &H0402
const as uinteger ERROR_server_maxclients_reached              = &H0403
const as uinteger ERROR_server_invalid_password                = &H0404
const as uinteger ERROR_server_is_virtual                      = &H0407
const as uinteger ERROR_server_is_not_running                  = &H0409
const as uinteger ERROR_server_is_booting                      = &H040a
const as uinteger ERROR_server_status_invalid                  = &H040b

' parameter
const as uinteger ERROR_parameter_quote                        = &H0600
const as uinteger ERROR_parameter_invalid_count                = &H0601
const as uinteger ERROR_parameter_invalid                      = &H0602
const as uinteger ERROR_parameter_not_found                    = &H0603
const as uinteger ERROR_parameter_convert                      = &H0604
const as uinteger ERROR_parameter_invalid_size                 = &H0605
const as uinteger ERROR_parameter_missing                      = &H0606

' unsorted, need further investigation
const as uinteger ERROR_vs_critical                            = &H0700
const as uinteger ERROR_connection_lost                        = &H0701
const as uinteger ERROR_not_connected                          = &H0702
const as uinteger ERROR_no_cached_connection_info              = &H0703
const as uinteger ERROR_currently_not_possible                 = &H0704
const as uinteger ERROR_failed_connection_initialisation       = &H0705
const as uinteger ERROR_could_not_resolve_hostname             = &H0706
const as uinteger ERROR_invalid_server_connection_handler_id   = &H0707
const as uinteger ERROR_could_not_initialise_input_manager     = &H0708
const as uinteger ERROR_clientlibrary_not_initialised          = &H0709
const as uinteger ERROR_serverlibrary_not_initialised          = &H070a
const as uinteger ERROR_whisper_too_many_targets               = &H070b
const as uinteger ERROR_whisper_no_targets                     = &H070c

' sound
const as uinteger ERROR_sound_preprocessor_disabled            = &H0900
const as uinteger ERROR_sound_internal_preprocessor            = &H0901
const as uinteger ERROR_sound_internal_encoder                 = &H0902
const as uinteger ERROR_sound_internal_playback                = &H0903
const as uinteger ERROR_sound_no_capture_device_available      = &H0904
const as uinteger ERROR_sound_no_playback_device_available     = &H0905
const as uinteger ERROR_sound_could_not_open_capture_device    = &H0906
const as uinteger ERROR_sound_could_not_open_playback_device   = &H0907
const as uinteger ERROR_sound_handler_has_device               = &H0908
const as uinteger ERROR_sound_invalid_capture_device           = &H0909
const as uinteger ERROR_sound_invalid_playback_device          = &H090a
const as uinteger ERROR_sound_invalid_wave                     = &H090b
const as uinteger ERROR_sound_unsupported_wave                 = &H090c
const as uinteger ERROR_sound_open_wave                        = &H090d
const as uinteger ERROR_sound_internal_capture                 = &H090e
const as uinteger ERROR_sound_device_in_use                    = &H090f
const as uinteger ERROR_sound_device_already_registerred       = &H0910
const as uinteger ERROR_sound_unknown_device                   = &H0911
const as uinteger ERROR_sound_unsupported_frequency            = &H0912
const as uinteger ERROR_sound_invalid_channel_count            = &H0913
const as uinteger ERROR_sound_read_wave                        = &H0914
const as uinteger ERROR_sound_need_more_data                   = &H0915 ' for internal purposes only
const as uinteger ERROR_sound_device_busy                      = &H0916 ' for internal purposes only
const as uinteger ERROR_sound_no_data                          = &H0917
const as uinteger ERROR_sound_channel_mask_mismatch            = &H0918

' accounting
const as uinteger ERROR_accounting_virtualserver_limit_reached = &H0b00
const as uinteger ERROR_accounting_slot_limit_reached          = &H0b01
const as uinteger ERROR_accounting_license_file_not_found      = &H0b02
const as uinteger ERROR_accounting_license_date_not_ok         = &H0b03
const as uinteger ERROR_accounting_unable_to_connect_to_server = &H0b04
const as uinteger ERROR_accounting_unknown_error               = &H0b05
const as uinteger ERROR_accounting_server_error                = &H0b06
const as uinteger ERROR_accounting_instance_limit_reached      = &H0b07
const as uinteger ERROR_accounting_instance_check_error        = &H0b08
const as uinteger ERROR_accounting_license_file_invalid        = &H0b09
const as uinteger ERROR_accounting_running_elsewhere           = &H0b0a
const as uinteger ERROR_accounting_instance_duplicated         = &H0b0b
const as uinteger ERROR_accounting_already_started             = &H0b0c
const as uinteger ERROR_accounting_not_started                 = &H0b0d
const as uinteger ERROR_accounting_to_many_starts              = &H0b0e

' provisioning server
const as uinteger ERROR_provisioning_invalid_password          = &H1100
const as uinteger ERROR_provisioning_invalid_request           = &H1101
const as uinteger ERROR_provisioning_no_slots_available        = &H1102
const as uinteger ERROR_provisioning_pool_missing              = &H1103
const as uinteger ERROR_provisioning_pool_unknown              = &H1104
const as uinteger ERROR_provisioning_unknown_ip_location       = &H1105
const as uinteger ERROR_provisioning_internal_tries_exceeded   = &H1106
const as uinteger ERROR_provisioning_too_many_slots_requested  = &H1107
const as uinteger ERROR_provisioning_too_many_reserved         = &H1108
const as uinteger ERROR_provisioning_could_not_connect         = &H1109
const as uinteger ERROR_provisioning_auth_server_not_connected = &H1110
const as uinteger ERROR_provisioning_auth_data_too_large       = &H1111

#endif ' PUBLIC_ERRORS_BI
